----------------------------------------------------------------------------------
--  npcGToTRP3
--  A lot of licenses only to transfer one string between two addons
-- -------------------------------------------------------------------------------
--  Copyright (C) 2018  Robert J.I. Hardy (Awyzuu)
--
--  This program is free software: you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program.  If not, see http://www.gnu.org/licenses.
----------------------------------------------------------------------------------

----------------------------------------------------------------------------------
--  npcGenerator 
--  generating npcs since 2016 instead of 2015
-- -------------------------------------------------------------------------------
--  Copyright (C) 2018  Robert J.I. Hardy (Awyzuu)
--  Copyright (C) 2018  Anya Flott-Nielsen (Acatiera)
--
--  This program is free software: you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program.  If not, see http://www.gnu.org/licenses.
----------------------------------------------------------------------------------

----------------------------------------------------------------------------------
-- Total RP 3
-- Dashboard
--	---------------------------------------------------------------------------
--	Copyright 2014 Sylvain Cossement (telkostrasz@telkostrasz.be)
--	Copyright 2014 Renaud Parize (Ellypse) (ellypse@totalrp3.info)
--
--	Licensed under the Apache License, Version 2.0 (the "License");
--	you may not use this file except in compliance with the License.
--	You may obtain a copy of the License at
--
--		http://www.apache.org/licenses/LICENSE-2.0
--
--	Unless required by applicable law or agreed to in writing, software
--	distributed under the License is distributed on an "AS IS" BASIS,
--	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
--	See the License for the specific language governing permissions and
--	limitations under the License.
---------------------------------------------------------------------------------


local output    = TRP3_NPCTalk.name
local frame     = npcGenerator_NPC_Frame
local npcSpeech = TRP3_NPCTalk
local input     = frame.Traits.Name.EditBox

function printToNPCSpeech()
  if not npcSpeech:IsVisible() then
    TRP3_API.r.showNPCTalkFrame() -- This initializes the frame, but also resets the channel.
  end
  --npcSpeech:Show()
	output:SetText(input:GetText())
end

local function HookMinimapButton()
	local optionsPane = npcGenerator_Options_UI_Panel
	
	-- Create new Checkbutton to allow adding the Minimap Button to TRP.
	optionsPane.LockMinimapButtonToTRP3 = CreateFrame("CheckButton", "npcGenerator_Options_UI_Panel_lockMinimapButtonToTRP3", optionsPane, "InterfaceOptionsCheckButtonTemplate")
	optionsPane.LockMinimapButtonToTRP3:SetPoint("TOPLEFT", optionsPane.LockMinimap, "BOTTOMLEFT", 0, 0)
	optionsPane.LockMinimapButtonToTRP3:SetScript("OnShow", function() optionsPane.LockMinimapButtonToTRP3:SetChecked(NPCG_TO_TRP3_Options.lockMinimapButtonToTRP3) end)
	optionsPane.LockMinimapButtonToTRP3:SetScript("PostClick",
		function()
			NPCG_TO_TRP3_Options.lockMinimapButtonToTRP3 = optionsPane.LockMinimapButtonToTRP3:GetChecked()
			if NPCG_TO_TRP3_Options.lockMinimapButtonToTRP3 then
				-- Transform Minimap Button to Total RP 3 style.
				-- Attach Minimap Button to Total RP 3 Toolbars.
			else
				-- 
			end
		end)
	getglobal(optionsPane.LockMinimapButtonToTRP3:GetName() .. "Text"):SetText("Use Total RP 3 Toolbar")
	
	-- Lower the "Tooltips" Header in the options menu.
	optionsPane.TooltipSettings:SetPoint("TOPLEFT", optionsPane.MinimapDescription, "BOTTOMLEFT", 0, -80)
end

function onLoad()
  npcGToTRP3_button = CreateFrame("Button", "npcGToTRP_button", frame)
  local button = npcGToTRP3_button
  button:SetNormalTexture("Interface\\GossipFrame\\GossipGossipIcon")
  button:SetHighlightTexture("Interface\\FriendsFrame\\BroadcastIcon")
  button:SetPushedTexture("Interface\\GossipFrame\\GossipGossipIcon")
  button:SetPoint("LEFT", frame.BottomBar, "LEFT", 5, 0)
  button:SetSize("22", "22")
  button:RegisterForClicks("LeftButtonDown")
  --button:SetScript("OnClick", function(...) print("Dickbutt") end)
  button:SetScript("OnClick", printToNPCSpeech)
  button:SetScript("OnEnter", function() SetHelperText("NPC Speech", button) end)
  frame.BottomBar.GenerateButton:SetPoint("LEFT", button, "RIGHT", 5, 0)
  frame.Traits.Name.EditBox:HookScript("OnTextChanged", function() if npcSpeech:IsVisible() then printToNPCSpeech() end end)
  
  speechWindowCharCounter = npcSpeech:CreateFontString("npcSpeechCharacterCounter", "OVERLAY", "npcGLabel")
  speechWindowCharCounter:SetPoint("BOTTOMLEFT", npcSpeech, "BOTTOMLEFT", 40, 20)
  
  
  local f = function()
    
    local NPCName = strtrim(npcSpeech.name:GetText())
    local message = npcSpeech.messageText.scroll.text:GetText()
    local channelType = npcSpeech.channelDropdown:GetSelectedValue()
    local channelTypeToStringBit = { MONSTER_SAY = "says: ",	MONSTER_EMOTE = "", MONSTER_YELL = "yells: ", MONSTER_WHISPER = "whispers: " }
    local channelData = channelTypeToStringBit[channelType]
    --local sendString = "| " .. NPCName .. " " .. channelData .. message
    
    local charactersUsed = strlen(NPCName .. message)
    local invariantStringBits = strlen("| " .. " " .. channelData)
    
    --local charactersUsed = strlen(sendString)
    
    --charactersUsed = charactersUsed
    maxSpeech = 254 - invariantStringBits-- THIS DEPENDS ON THE CHANNEL!
    
    local color = function() return 1, 1, 1, 1 end
    if charactersUsed >= maxSpeech * 0.85 then
      color = function()     return 1, 1, 0, 1 end
    end
    if charactersUsed > maxSpeech then
      color = function()     return 1, 0, 0, 1 end
    end
    speechWindowCharCounter:SetTextColor(color())
    
    
    speechWindowCharCounter:SetText(charactersUsed .. "/" .. maxSpeech)
  end
  
  npcSpeechCharacterCounter:Hide()
  --speechWindowCharCounter:SetText("0/254")
  --npcSpeech.messageText.scroll.text:HookScript("OnTextChanged", f)
  --npcSpeech.messageText.scroll.text:HookScript("OnEditFocusGained", f)
  --npcSpeech.name:HookScript("OnTextChanged", f)
  --npcSpeech.name:HookScript("OnEditFocusGained", f)


  
  local oldOnTabChanged = frame.Tabs.OnTabChanged
  frame.Tabs.OnTabChanged = function(tabIndex)
    oldOnTabChanged(tabIndex)
    if npcSpeech:IsVisible() then
      printToNPCSpeech()
    end
  end
	
	--HookMinimapButton()
end



onLoad()

